ON_Geometry Class Referenceabstract

`#include <pcl/surface/3rdparty/opennurbs/opennurbs_geometry.h>`

Inheritance diagram for ON_Geometry:

## Public Member Functions

| ON_Geometry ()
| ON_Geometry (const ON_Geometry &)
ON_Geometry & | operator= (const ON_Geometry &)
virtual | ~ON_Geometry ()
ON_BoundingBox | BoundingBox () const
ON_BOOL32 | GetBoundingBox (ON_BoundingBox &bbox, int bGrowBox=false) const
ON_BOOL32 | GetBoundingBox (ON_3dPoint &bbox_min, ON_3dPoint &bbox_max, int bGrowBox=false) const
ON_BOOL32 | Rotate (double sin_angle, double cos_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
ON_BOOL32 | Rotate (double rotation_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
ON_BOOL32 | Translate (const ON_3dVector &translation_vector)
ON_BOOL32 | Scale (double scale_factor)
virtual int | Dimension () const =0
virtual ON_BOOL32 | GetBBox (double *boxmin, double *boxmax, int bGrowBox=false) const =0
virtual bool | GetTightBoundingBox (ON_BoundingBox &tight_bbox, int bGrowBox=false, const ON_Xform *xform=0) const
virtual void | ClearBoundingBox ()
virtual ON_BOOL32 | Transform (const ON_Xform &xform)
virtual bool | IsDeformable () const
virtual bool | MakeDeformable ()
virtual ON_BOOL32 | SwapCoordinates (int i, int j)
virtual ON_BOOL32 | HasBrepForm () const
virtual ON_Brep * | BrepForm (ON_Brep *brep=NULL) const
virtual ON_COMPONENT_INDEX | ComponentIndex () const
virtual bool | EvaluatePoint (const class ON_ObjRef &objref, ON_3dPoint &P) const
Public Member Functions inherited from ON_Object
bool | CopyFrom (const ON_Object *src)
| ON_Object ()
| ON_Object (const ON_Object &)
ON_Object & | operator= (const ON_Object &)
virtual | ~ON_Object ()
void | EmergencyDestroy ()
virtual void | MemoryRelocate ()
ON_BOOL32 | IsKindOf (const ON_ClassId *pClassId) const
virtual ON_BOOL32 | IsValid (ON_TextLog *text_log=NULL) const =0
virtual void | Dump (ON_TextLog &) const
virtual unsigned int | SizeOf () const
virtual ON__UINT32 | DataCRC (ON__UINT32 current_remainder) const
virtual ON_BOOL32 | Write (ON_BinaryArchive &binary_archive) const
virtual ON_BOOL32 | Read (ON_BinaryArchive &binary_archive)
virtual ON::object_type | ObjectType () const
virtual ON_UUID | ModelObjectId () const
bool | SetUserString (const wchar_t *key, const wchar_t *string_value)
int | SetUserStrings (int count, const ON_UserString *user_strings, bool bReplace)
bool | GetUserString (const wchar_t *key, ON_wString &string_value) const
int | GetUserStrings (ON_ClassArray< ON_UserString > &user_strings) const
int | GetUserStringKeys (ON_ClassArray< ON_wString > &user_string_keys) const
int | UserStringCount () const
ON_BOOL32 | AttachUserData (ON_UserData *pUserData)
ON_BOOL32 | DetachUserData (ON_UserData *pUserData)
ON_UserData * | GetUserData (const ON_UUID &userdata_uuid) const
void | PurgeUserData ()
ON_UserData * | FirstUserData () const
void | TransformUserData (const ON_Xform &xform)
void | CopyUserData (const ON_Object &source_object)
void | MoveUserData (ON_Object &source_object)
virtual void | DestroyRuntimeCache (bool bDelete=true)

## Detailed Description

Definition at line 36 of file opennurbs_geometry.h.

## Constructor & Destructor Documentation

## ON_Geometry() [1/2]

ON_Geometry::ON_Geometry | ( |  | ) |

## ON_Geometry() [2/2]

ON_Geometry::ON_Geometry | ( | const ON_Geometry & |  | ) |

## ~ON_Geometry()

virtual ON_Geometry::~ON_Geometry | ( |  | ) |

virtual

## Member Function Documentation

## BoundingBox()

ON_BoundingBox ON_Geometry::BoundingBox | ( |  | ) | const

## BrepForm()

virtual ON_Brep* ON_Geometry::BrepForm | ( | ON_Brep * | brep = `NULL` | ) | const

virtual

Reimplemented in ON_Brep, ON_MorphControl, ON_Surface, and ON_Extrusion.

## ClearBoundingBox()

virtual void ON_Geometry::ClearBoundingBox | ( |  | ) |

virtual

Reimplemented in ON_Brep, ON_MorphControl, ON_BrepFace, ON_SumSurface, and ON_RevSurface.

## ComponentIndex()

virtual ON_COMPONENT_INDEX ON_Geometry::ComponentIndex | ( |  | ) | const

virtual

Reimplemented in ON_MeshFaceRef, ON_MeshEdgeRef, ON_MeshVertexRef, ON_BrepFace, ON_BrepLoop, ON_BrepTrim, ON_BrepEdge, and ON_BrepVertex.

## Dimension()

virtual int ON_Geometry::Dimension | ( |  | ) | const

pure virtual

Implemented in ON_MeshFaceRef, ON_MeshEdgeRef, ON_MeshVertexRef, ON_TextDot, ON_Brep, ON_MorphControl, ON_NurbsCage, ON_Mesh, ON_BrepLoop, ON_Hatch, ON_InstanceRef, ON_Annotation2, ON_NurbsSurface, ON_NurbsCurve, ON_CurveProxy, ON_Annotation, ON_SumSurface, ON_RevSurface, ON_ArcCurve, ON_PolyCurve, ON_Viewport, ON_AnnotationArrow, ON_InstanceDefinition, ON_SurfaceProxy, ON_PolylineCurve, ON_CurveOnSurface, ON_PlaneSurface, ON_Point, ON_PointGrid, ON_LineCurve, ON_Light, ON_PointCloud, ON_Extrusion, and ON_DetailView.

## EvaluatePoint()

virtual bool ON_Geometry::EvaluatePoint | ( | const class ON_ObjRef & | objref,
|  | ON_3dPoint & | P
| ) |  | const

virtual

Reimplemented in ON_Brep, ON_Mesh, ON_Annotation2, ON_PolyCurve, ON_Curve, and ON_Surface.

## GetBBox()

virtual ON_BOOL32 ON_Geometry::GetBBox | ( | double * | boxmin,
|  | double * | boxmax,
|  | int | bGrowBox = `false`
| ) |  | const

pure virtual

Implemented in ON_MeshFaceRef, ON_MeshEdgeRef, ON_MeshVertexRef, ON_TextDot, ON_Leader2, ON_TextEntity2, ON_Brep, ON_OrdinateDimension2, ON_MorphControl, ON_AngularDimension2, ON_RadialDimension2, ON_NurbsCage, ON_LinearDimension2, ON_BrepFace, ON_Mesh, ON_BrepLoop, ON_Hatch, ON_InstanceRef, ON_OffsetSurface, ON_NurbsSurface, ON_NurbsCurve, ON_CurveProxy, ON_Annotation, ON_SumSurface, ON_Viewport, ON_RevSurface, ON_ArcCurve, ON_PolyCurve, ON_AnnotationArrow, ON_InstanceDefinition, ON_SurfaceProxy, ON_PolylineCurve, ON_CurveOnSurface, ON_PlaneSurface, ON_Point, ON_PointGrid, ON_LineCurve, ON_Light, ON_PointCloud, ON_Extrusion, and ON_DetailView.

## GetBoundingBox() [1/2]

ON_BOOL32 ON_Geometry::GetBoundingBox | ( | ON_BoundingBox & | bbox,
|  | int | bGrowBox = `false`
| ) |  | const

## GetBoundingBox() [2/2]

ON_BOOL32 ON_Geometry::GetBoundingBox | ( | ON_3dPoint & | bbox_min,
|  | ON_3dPoint & | bbox_max,
|  | int | bGrowBox = `false`
| ) |  | const

## GetTightBoundingBox()

virtual bool ON_Geometry::GetTightBoundingBox | ( | ON_BoundingBox & | tight_bbox,
|  | int | bGrowBox = `false`,
|  | const ON_Xform * | xform = `0`
| ) |  | const

virtual

Reimplemented in ON_Leader2, ON_TextEntity2, ON_OrdinateDimension2, ON_MorphControl, ON_AngularDimension2, ON_RadialDimension2, ON_NurbsCage, ON_LinearDimension2, ON_Mesh, ON_Hatch, ON_ArcCurve, ON_Curve, ON_PolyCurve, ON_PolylineCurve, ON_PointGrid, ON_LineCurve, ON_PointCloud, ON_Extrusion, and ON_DetailView.

## HasBrepForm()

virtual ON_BOOL32 ON_Geometry::HasBrepForm | ( |  | ) | const

virtual

Reimplemented in ON_Brep, ON_MorphControl, and ON_Surface.

## IsDeformable()

virtual bool ON_Geometry::IsDeformable | ( |  | ) | const

virtual

Reimplemented in ON_TextDot, ON_NurbsCage, ON_Mesh, ON_InstanceRef, ON_NurbsSurface, ON_NurbsCurve, ON_SumSurface, ON_PolyCurve, ON_PolylineCurve, ON_PointGrid, ON_LineCurve, ON_PointCloud, and ON_Point.

## MakeDeformable()

virtual bool ON_Geometry::MakeDeformable | ( |  | ) |

virtual

Reimplemented in ON_TextDot, ON_NurbsCage, ON_Mesh, ON_InstanceRef, ON_NurbsSurface, ON_NurbsCurve, ON_SumSurface, ON_PolyCurve, ON_PolylineCurve, ON_PointGrid, ON_LineCurve, ON_PointCloud, and ON_Point.

## operator=()

ON_Geometry& ON_Geometry::operator= | ( | const ON_Geometry & |  | ) |

## Rotate() [1/2]

ON_BOOL32 ON_Geometry::Rotate | ( | double | sin_angle,
|  | double | cos_angle,
|  | const ON_3dVector & | rotation_axis,
|  | const ON_3dPoint & | rotation_center
| ) |  |

## Rotate() [2/2]

ON_BOOL32 ON_Geometry::Rotate | ( | double | rotation_angle,
|  | const ON_3dVector & | rotation_axis,
|  | const ON_3dPoint & | rotation_center
| ) |  |

## Scale()

ON_BOOL32 ON_Geometry::Scale | ( | double | scale_factor | ) |

## SwapCoordinates()

virtual ON_BOOL32 ON_Geometry::SwapCoordinates | ( | int | i,
|  | int | j
| ) |  |

virtual

Reimplemented in ON_Brep, ON_Mesh, ON_NurbsSurface, ON_NurbsCurve, ON_PolyCurve, ON_PolylineCurve, ON_PointGrid, ON_LineCurve, ON_PointCloud, ON_CurveOnSurface, and ON_Point.

## Transform()

virtual ON_BOOL32 ON_Geometry::Transform | ( | const ON_Xform & | xform | ) |

virtual

Reimplemented in ON_MeshFaceRef, ON_MeshEdgeRef, ON_MeshVertexRef, ON_TextDot, ON_Leader2, ON_TextEntity2, ON_Brep, ON_MorphControl, ON_OrdinateDimension2, ON_AngularDimension2, ON_RadialDimension2, ON_NurbsCage, ON_Mesh, ON_LinearDimension2, ON_BrepLoop, ON_Hatch, ON_InstanceRef, ON_Annotation2, ON_NurbsSurface, ON_NurbsCurve, ON_CurveProxy, ON_Annotation, ON_SumSurface, ON_ArcCurve, ON_Viewport, ON_PolyCurve, ON_RevSurface, ON_PolylineCurve, ON_AnnotationArrow, ON_SurfaceProxy, ON_InstanceDefinition, ON_PointGrid, ON_LineCurve, ON_CurveOnSurface, ON_PlaneSurface, ON_PointCloud, ON_Point, ON_Light, ON_Extrusion, and ON_DetailView.

## Translate()

ON_BOOL32 ON_Geometry::Translate | ( | const ON_3dVector & | translation_vector | ) |

The documentation for this class was generated from the following file:

- /build/pcl-qv3n_B/pcl-1.8.1+dfsg1/surface/include/pcl/surface/3rdparty/opennurbs/opennurbs_geometry.h